Graphics3D 640,480,32,2
SetBuffer( BackBuffer() )

AmbientLight 150,150,150
light = CreateLight(1)
PositionEntity light, 0,0,-20
LightColor light,200,10,10
LightRange light,2000

cam = CreateCamera()
CameraRange cam,1,2000
PositionEntity cam,0,0,-4
CameraFogMode cam,1
CameraFogRange cam,10,500
CameraFogColor cam,150,70,50
CameraClsMode cam,False,True

ball = CreateSphere(16)
EntityColor ball,100,0,50
EntityAlpha ball,.5
EntityType ball,2

tube = CreateMesh()
surf = CreateSurface(tube)
Local ring[8]
ring[0] = AddVertex(surf,8,0,-4)
ring[1] = AddVertex(surf,6,6,-4)
ring[2] = AddVertex(surf,0,8,-4)
ring[3] = AddVertex(surf,-6,6,-4)
ring[4] = AddVertex(surf,-8,0,-4)
ring[5] = AddVertex(surf,-6,-6,-4)
ring[6] = AddVertex(surf,0,-8,-4)
ring[7] = AddVertex(surf,6,-6,-4)
l = Input ("length(~10):")
SeedRnd MilliSecs()
For c=0 To l
  dx# = Rnd(-1.0,1.0)/10.0
  dy# = Rnd(-1.0,1.0)/10.0
  For r=0 To 19
    ring[8] = grow_tube(surf,ring , r*dx#,r*dy#)
  Next
Next
UpdateNormals tube
EntityParent cam, ball, False
EntityFX tube,34
EntityType tube,1

target = CreateSphere(8)
EntityColor target,250,50,200
ScaleEntity target,5,5,5
EntityType target,3
PositionEntity target,VertexX(surf,ring[2]),VertexY(surf,ring[0]),VertexZ(surf,ring[0])

WireEnabled = True
WireFrame(WireEnabled)
zoom# = 1.0
Dim star(1000,2)
For s=0 To 999
  star(s,0) = Rnd(0,640)
  star(s,1) = Rnd(0,480)
Next
gameover = False
won = False
spd#=.0

While Not KeyHit(1)
  Cls
  CameraZoom cam,zoom#
  If KeyHit(57) Then WireEnabled = Not WireEnabled : WireFrame(WireEnabled)
  If KeyDown(200) Then TurnEntity ball,-1,0,0
  If KeyDown(208) Then TurnEntity ball,1,0,0
  If KeyDown(203) Then TurnEntity ball,0,1,0
  If KeyDown(205) Then TurnEntity ball,0,-1,0
  MoveEntity ball,0,0,spd#
  If zoom# > 0.4  And gameover=False And won=False Then zoom# = zoom# - .01 : spd# = spd# + .01
  If gameover And spd# > 0.002 Then spd# = spd# - .002
  If won And spd# > 0.002 Then spd# = spd# - .002
  If spd# <= 0.01 And gameover And zoom# <= .9 Then zoom# = zoom# + .01
  If spd# <= 0.01 And won And zoom# <= .9 Then zoom# = zoom# + .01
  Collisions 2,1,2,3
  For s=0 To 999
    Color 50,50,50
    Plot star(s,0)+EntityYaw(ball),star(s,1)+EntityPitch(ball)
  Next
  If EntityCollided(ball,1) = tube Then gameover = True
  If MeshesIntersect(ball,target) Then won = True
  UpdateWorld
  RenderWorld
  Color 180,0,0
  If gameover Then
    Text 310,270, "Game Over(Crashed)"
  ElseIf won
    Color 55,250,55
    Text 310,270, "You've won!!"
  EndIf
  Color 250,250,250
  Text 0,0,"Vertices: "+CountVertices(surf)
  Text 100,0,"Steuerung: Pfeiltasten oder w,a,s,d   Ziel: nicht crashen und zielkugel erreichen!!"
  Flip
Wend
End

;adds a ring to the tube
Function grow_tube(surface,ring[8], dir_x#,dir_y#)
  head_z# = VertexZ(surface,ring[0]) + 2
  head_x# = VertexX(surface,ring[2])
  head_y# = VertexY(surface,ring[0])
  Local newring[8]
 
  x# = head_x + dir_x
  y# = head_y + dir_y
 
  newring[0] = AddVertex(surface,x+12,y+0,head_z)
  newring[1] = AddVertex(surface,x+9,y+9,head_z)
  newring[2] = AddVertex(surface,x+0,y+12,head_z)
  newring[3] = AddVertex(surface,x-9,y+9,head_z)
  newring[4] = AddVertex(surface,x-12,y+0,head_z)
  newring[5] = AddVertex(surface,x-9,y-9,head_z)
  newring[6] = AddVertex(surface,x+0,y-12,head_z)
  newring[7] = AddVertex(surface,x+9,y-9,head_z)
 
  For v=0 To 7
    AddTriangle(surface,newring[v],ring[(v+1)-(v/7)*8],ring[v])
  Next
 
  For v=0 To 7
    AddTriangle(surface,newring[(v+1)-(v/7)*8],ring[(v+1)-(v/7)*8],newring[v])
  Next
 
  For v=0 To 7 Step 2
    VertexColor surface,newring[v],100,0,150,1.0
    VertexColor surface,newring[v+1],100,50,250,0.0
  Next
 
  For i=0 To 7
    ring[i] = newring[i]
  Next
  Return ring[8]
  
End Function